{

Character mode TV Text driver, with font table   Rev 01


}

CON
  ' Proto/Demo Board setup
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   TV_BASE_PIN = 12
   KEYSPIN   = 26

{   
  ' Hydra setup
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

   TV_BASE_PIN = 24 
   KEYSPIN  = 13   
}

{
' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
   
   TV_BASE_PIN = 24    
   KEYSPIN  = 12 
}

'' gamepad pin configuration (adjust for your setup)
  JOY_CLK = 16
  JOY_LCH = 17
  JOY_DATAOUT0 = 18
  JOY_DATAOUT1 = 19  
  
  ' NES bit encodings for NES gamepad 0
  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000  
{
    Here is the color table, for reference:

    $02, $03, $04, $05, $06, $07                      Six intensities
    $19, $1a, $1b, $1c, $1d, $1e, $98, $af            Magenta
    $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
    $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
    $49, $4a, $4b, $4c, $4d, $4e, $c8, $df            Red
    $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef            
    $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff            Orange
    $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
    $89, $8a, $8b, $8c, $8d, $8e, $08, $1f            
    $99, $9a, $9b, $9c, $9d, $9e, $18, $2f            Green
    $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f            
    $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
    $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f            
    $d9, $da, $db, $dc, $dd, $de, $58, $6f            Blue
    $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f            
    $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f
                                                        
    This table is missing one hue, those values are:        $0a, $0b, $0c, $0d, $0e, $0f    Darker Blue  
}
  COLOR_BLACK  = $02
  COLOR_BROWN  = $5d
  COLOR_YELLOW = $6e
  COLOR_WHITE  = $07
  COLOR_GREEN  = $9e
  COLOR_RED    = $4b
  COLOR_PURPLE = $2b
  COLOR_CYAN   = $58

  'direction constants
  DIR_SOUTH = 0
  DIR_NORTH = 2
  DIR_WEST  = 4
  DIR_EAST  = 6

VAR
  word Nes_Pad

  byte player_dir      'the player direction
  byte player_step     'the step the player is on
  byte player_x        'x position
  byte player_y        'y position

OBJ
  text : "LinkDemo_TV_Text_001"  'the TV display driver
  key  : "comboKeyboard" 
  
PUB start 

    'start the tv text driver
    text.start(TV_BASE_PIN) 
    key.start(KEYSPIN)  
    player_dir  := DIR_SOUTH
    player_step := 0
    player_x    := 9
    player_y    := 8
    
    'set up the game loop
    repeat            
      'clear previous contents of the screen 
      'text.Cls   

      'draw the background map
      DrawMap
          
      'Check for gamepad events
      CheckGamePad

      'draw the player 
      DrawPlayer

      'wait for the Vertical Sync
      text.Vwait

      'waitcnt(5_000_000 + cnt)
          
PRI DrawMap | ptr, x, y
    ptr := @mapinfo
    repeat x from 1 to 16
       repeat y from 1 to 16
          if byte[ptr] > $20
             text.PokeChar(x,y,COLOR_RED,COLOR_BLACK, byte[ptr])
          else
             text.PokeChar(x,y,COLOR_YELLOW,COLOR_BROWN, byte[ptr])
          ptr++

PRI CheckGamePad
     Nes_Pad := NES_Read_Gamepad                 
     if (Nes_Pad & NES0_DOWN)
        player_x++
                
     if (Nes_Pad & NES0_UP)
        player_x--
                
     if (Nes_Pad & NES0_LEFT)
        player_y--
                
     if (Nes_Pad & NES0_RIGHT)
         player_y++
                
PRI DrawPlayer | offset
    offset := player_dir + player_step
    text.PokeChar(player_x - 1, player_y, COLOR_YELLOW,COLOR_BROWN,$02 + offset)
    text.PokeChar(player_x, player_y ,COLOR_GREEN,COLOR_BROWN,$22 + offset)
     
PRI NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)                            

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
 
 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' Keyboard (mapped onto NES buttons)
    if(key.keystate($C2))       'Up Arrow
      nes_bits|=NES0_UP
    if(key.keystate($C3))       'Down Arrow
      nes_bits|=NES0_DOWN
    if(key.keystate($C0))       'Left Arrow
      nes_bits|=NES0_LEFT
    if(key.keystate($C1))       'Right Arrow
      nes_bits|=NES0_RIGHT
    if(key.keystate($0D))       'Enter
      nes_bits|=NES0_START
    if(key.keystate(" "))       'Space
      nes_bits|=NES0_B

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////             
DAT
mapinfo byte $64, $64, $64, $64, $64, $64, $64, $20, $20, $64, $64, $64, $64, $64, $64, $64       
        byte $64, $64, $64, $64, $64, $64, $20, $20, $20, $20, $64, $64, $64, $64, $64, $64
        byte $64, $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64, $64
        byte $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64
        byte $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64
        byte $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64
        byte $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64
        byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
        byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
        byte $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64
        byte $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64
        byte $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64
        byte $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64
        byte $64, $64, $64, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $64, $64, $64             
        byte $64, $64, $64, $64, $64, $64, $20, $20, $20, $20, $64, $64, $64, $64, $64, $64       
        byte $64, $64, $64, $64, $64, $64, $64, $20, $20, $64, $64, $64, $64, $64, $64, $64        